Package: consensus
Title: Cross-platform consensus analysis of genomic measurements via
        interlaboratory testing method
Version: 1.28.0
Date: 2020-05-22
Author: Tim Peters
Maintainer: Tim Peters <t.peters@garvan.org.au>
Authors@R: c(person("Tim", "Peters", role = c("cre", "aut"),
                    email = "t.peters@garvan.org.au"),
	     person("Benedetta Frida", "Baldi", role = "art",
		    email = "b.baldi@garvan.org.au"))
Description: An implementation of the American Society for Testing and Materials (ASTM) Standard E691 for interlaboratory testing procedures, designed for cross-platform genomic measurements. Given three (3) or more genomic platforms or laboratory protocols, this package provides interlaboratory testing procedures giving per-locus comparisons for sensitivity and precision between platforms.   
Depends: R (>= 3.5), RColorBrewer
Imports: matrixStats, gplots, grDevices, methods, graphics, stats,
        utils
biocViews: QualityControl, Regression, DataRepresentation,
        GeneExpression, Microarray, RNASeq
Suggests: knitr, RUnit, rmarkdown, BiocGenerics
License: BSD_3_clause + file LICENSE
VignetteBuilder: knitr
git_url: https://git.bioconductor.org/packages/consensus
git_branch: RELEASE_3_22
git_last_commit: 41b16d0
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29
NeedsCompilation: no
Packaged: 2025-10-30 03:16:20 UTC; biocbuild

fitMandel <- function(multimeas, idx){
  
  block <- getBlock(multimeas, idx)
  xj <- colMeans(block)
  mui <- rowMeans(block)
  gammahatj <- xj - mean(xj)
  betahati <- colSums(apply(block, 1, function (x) x*gammahatj))/sum(gammahatj^2)
  
  fitted.nores <- mui + betahati %*% t(gammahatj)
  etaij <- block - fitted.nores
  
  ssr <- apply(etaij, 1, function (x) sum(x^2))
  vhatieta <- ssr/(ncol(block)-2)
  veta <- sum(vhatieta)/(nrow(block)-1)
  vmu <- var(mui)
  vbeta <- var(betahati)
  
  alphahat <- (sum((betahati - 1)*(mui-mean(mui))))/sum((mui-mean(mui))^2)
  residuals <- sapply(seq_len(nrow(block)), function (x) (betahati[x]-1) - alphahat*(mui[x]-mean(mui)))
  vdelta <- sum(residuals^2)/(nrow(block)-2)
  z0 <- mean(mui) - 1/alphahat
  
  if (idx %% 10000 == 0) message(paste0("Fit ", idx, " loci..."))
  
  return(list(a_i=mui, b_i=betahati, d_i=vhatieta, vd=veta, vdelta=vdelta, z0=z0))
}

setMethod("show", "MultiMeasure",
          function (object) cat(paste0("MultiMeasure object with ",
                                       length(object@data), " platforms/conditions, ",
                                       ncol(object@data[[1]]), " samples and ", 
                                       nrow(object@data[[1]]), " measured loci.\n"))
)

setMethod("show", "ConsensusFit",
          function (object) cat(paste0("ConsensusFit object with ",
                                       ncol(object@a_i), " platforms/conditions and ",
                                       nrow(object@a_i), " measured loci.\n"))
)

checkMM <- function(object) {
  
  length_names <- length(object@names)
  length_data <- length(object@data)
  
  if (length_names != length_data) {
    stop(paste0("Length of names vector *must* be equal to number of data matrices provided. \n
                Matrices: ", length_data, ". Names provided: ", length_names))
  }
  
  if (length_data < 3) {
    stop("Must be at least 3 matrices for a consensus fit.")
  }
  
  dims <- lapply(object@data, dim)
  names(dims) <- object@names
  dimcheck <- outer(dims, dims, Vectorize(all.equal))
  dimcheck[dimcheck!="TRUE"] <- "FALSE"
  dimcheck <- matrix(as.logical(dimcheck), nrow(dimcheck), ncol(dimcheck))
  rownames(dimcheck) <- colnames(dimcheck) <- object@names
  if (!all(dimcheck)){
    message("Error: Not all matrix dimensions are identical across platforms. Dimension equalities:")
    print(dimcheck)
    stop()
  }
  
  columnnames <- lapply(object@data, colnames)
  names(columnnames) <- object@names
  colcheck <- outer(columnnames, columnnames, Vectorize(all.equal))
  colcheck[colcheck!="TRUE"] <- "FALSE"
  colcheck <- matrix(as.logical(colcheck), nrow(colcheck), ncol(colcheck))
  rownames(colcheck) <- colnames(colcheck) <- object@names
  if (!all(colcheck)){
    message("Error: Not all sample names (colnames) are identical across platforms. Equalities:")
    print(colcheck)
    stop()
  }
  
  locusnames <- lapply(object@data, rownames)
  names(locusnames) <- object@names
  rowcheck <- outer(locusnames, locusnames, Vectorize(all.equal))
  rowcheck[rowcheck!="TRUE"] <- "FALSE"
  rowcheck <- matrix(as.logical(rowcheck), nrow(rowcheck), ncol(rowcheck))
  rownames(rowcheck) <- colnames(rowcheck) <- object@names
  if (!all(rowcheck)){
    message("Error: Not all locus names (rownames) are identical across platforms. Equalities:")
    print(rowcheck)
    stop()
  }
  
  TRUE
  }


setClass("MultiMeasure", 
         representation(names="character", data = "list"),
         prototype(names=NA_character_, data=list()),
         validity = checkMM)



setClass("ConsensusFit",
         representation(a_i="matrix", b_i="matrix", d_i="matrix", V_a="numeric", V_b="numeric", 
                        V_d="numeric", z0="numeric", Vdelta="numeric"))

plotMarginals <- function (consfit, param = c("average", "sensitivity", "precision"), 
          pal = palette(), xlim = NULL, ...) 
{
  stopifnot(is(consfit, "ConsensusFit"))
  param <- match.arg(param)
  if (length(pal) < ncol(consfit@a_i)) {
    stop("Palette size must be at least the number of platforms/conditions")
  }
  toplot <- switch(param, average = {
    consfit@a_i
  }, sensitivity = {
    consfit@b_i
  }, precision = {
    log(consfit@d_i)
  })
  
  if (is.null(xlim)) {
    xlim = range(toplot)
  } else {
    toplot <- toplot[apply(toplot, 1, function (x) all(x>=xlim[1] & x<=xlim[2])),]
  }
  densities <- apply(toplot, 2, density)
  maxdens <- max(unlist(lapply(densities, function(x) max(x$y))))
  plabel <- switch(param, average = {
    "a_i"
  }, sensitivity = {
    "b_i"
  }, precision = "Log (d_i)")
  plot(1, 1, xlim = xlim, ylim = c(-(maxdens/10), maxdens), 
       type = "n", xlab = plabel, ylab = "Density", main = paste0("Marginals: ", 
                                                                  param))
  for (i in seq_len(ncol(toplot))) {
    lines(densities[[i]], lwd = 2, col = pal[i])
  }
  abline(h = 0, col = "gray")
  legend(min(toplot), 0, colnames(toplot), text.col = pal, 
         horiz = TRUE, bty = "n", ...)
}

plotOneFit <- function(multimeas, idx, pal=palette(), ...){
  
  if(length(pal) < length(multimeas@data)){
    stop("Palette size must be at least the number of platforms/conditions")
  }
  
  if(!idx %in% rownames(multimeas@data[[1]])){
    stop("Gene ID is not recognised. Check rownames of the data you passed to MultiMeasure().")
  }
  
  block <- getBlock(multimeas, idx)
  
  plotrange <- range(block)
  #Add 10% at bottom for legend
  plotrange[1] <- plotrange[1] - diff(plotrange)*0.1
  
  means <- colMeans(block)
  
  plot(means, seq_len(length(means)), ylim=plotrange, xlab="Sample means", ylab="Sample measurements", main=idx, type="n")
  
  for (i in seq_len(nrow(block))){
    
    points(means, block[i,], pch=16, col=pal[i], cex=1.3)
    fit.one <- lm(as.numeric(block[i,]) ~ means)
    abline(fit.one, col=pal[i])
    
  }
  
  legend(min(means), min(block), names(multimeas), text.col=pal, horiz=TRUE, bty="n", ...)
  
}

plotMostDiscordant <- function(consfit, param=c("average", "sensitivity", "precision"), 
                               numloci=20, pal=colorRampPalette(brewer.pal(9, "RdYlGn"))){
  
  stopifnot(is(consfit,"ConsensusFit"))
  param <- match.arg(param)
  
  by <- switch(param, average = {length(consfit@V_a) - rank(consfit@V_a) + 1}, 
               sensitivity = {length(consfit@V_b) - rank(consfit@V_b) + 1}, 
               precision = {length(consfit@V_d) - rank(consfit@V_d) + 1})
  
  toplot <- switch(param, average = {consfit@a_i}, sensitivity = {consfit@b_i}, precision = {log(consfit@d_i)})
  toplot <- toplot[by %in% seq_len(numloci),]
  
  heatmap.2(toplot,
            density.info="none",  
            trace="none",         
            margins =c(12,8),     
            col=pal(100),       
            dendrogram="none",     
            key.xlab = param) 
  
}

fitConsensus <- function(multimeas){
  
  mandel_results <- lapply(seq_len(nrow(multimeas@data[[1]])), function (x) fitMandel(multimeas, x))
  
  a_i <- do.call(rbind, lapply(mandel_results, function (x) x$a_i))
  b_i <- do.call(rbind, lapply(mandel_results, function (x) x$b_i))
  d_i <- do.call(rbind, lapply(mandel_results, function (x) x$d_i))
  
  V_a <- rowVars(a_i)
  V_b <- rowVars(b_i)
  V_d <- unlist(lapply(mandel_results, function (x) x$vd))
  
  z0 <- unlist(lapply(mandel_results, function (x) x$z0))
  Vdelta <- unlist(lapply(mandel_results, function (x) x$vdelta))
  
  rownames(a_i) <- rownames(b_i) <- rownames(d_i) <- names(V_a) <- names(V_b) <- names(V_d) <- names(z0) <- names(Vdelta) <- rownames(multimeas@data[[1]])
  colnames(a_i) <- colnames(b_i) <- colnames(d_i) <- multimeas@names
  
  new("ConsensusFit", a_i=a_i, b_i=b_i, d_i=d_i, V_a=V_a, V_b=V_b, V_d=V_d, z0=z0, Vdelta=Vdelta)
  
}

setGeneric("MultiMeasure",  valueClass = "MultiMeasure", function(names=NA_character_, data.matrices=list()) {
  standardGeneric("MultiMeasure")
})

setGeneric("fitConsensus",  valueClass = "ConsensusFit", function(multimeas) {
  standardGeneric("fitConsensus")
})

setGeneric("plotOneFit", function(multimeas, idx, pal=palette()) {
  standardGeneric("plotOneFit")
})

setGeneric("plotMarginals", function(consfit, param=c("average", "sensitivity", "precision"), pal=palette()){
  standardGeneric("plotMarginals")
})

setGeneric("plotMostDiscordant", function(consfit, param=c("average", "sensitivity", "precision"), 
                                          numloci=20, pal=colorRampPalette(brewer.pal(9, "RdYlGn"))) {
  standardGeneric("plotMostDiscordant")
})

\name{plotMostDiscordant}
\alias{plotMostDiscordant}
\title{
Plot a heatmap showing a selection of loci
}
\description{
Plots a heatmap of a specified number of loci showing per-platform, values for either (a) average (\eqn{a_i}), (b) sensitivity (\eqn{b_i}) or (c) precision (\eqn{d_i}) for the most discordant for each. Discordance is ranked by \eqn{V(a_i)}, \eqn{V(b_i)} or \eqn{\frac{\Sigma(d_i)}{p-1}} where \eqn{p=} the number of platforms/conditions. 
}
\usage{
plotMostDiscordant(consfit, param=c("average", "sensitivity", "precision"), 
                   numloci=20, pal=colorRampPalette(brewer.pal(9, "RdYlGn")))
}

\arguments{
  \item{consfit}{An object of class \code{ConsensusFit}.}
  \item{param}{Whether average (\eqn{a_i}), sensitivity (\eqn{b_i}) or precision (\eqn{d_i}) is plotted.}
  \item{numloci}{The number of loci to plot.}
  \item{pal}{Colour palette. Length must be at least the number of platforms/conditions.}
}

\value{
A plot to the current device.
}

\author{
Tim Peters <t.peters@garvan.org.au>
}
\examples{
data("TCGA")
tcga_mm <- MultiMeasure(names=c("U133A", "Huex", "Agilent", "RNASeq"), 
			data=list(U133A, Huex, Agilent, RNASeq))
fit <- fitConsensus(tcga_mm)
plotMostDiscordant(fit, "sensitivity", 25)
}

\name{RNASeq}
\alias{RNASeq}
\docType{data}
\title{
RNA-Seq gene expression data
}
\description{
Limma-voom normalised gene expression data from 27 Glioblastoma Multiforme (GBM) patients measured via RNA-Seq.
}
\usage{data("TCGA")}
\format{
Numeric matrix.
}
\source{
\url{https://portal.gdc.cancer.gov/}
}
\references{
Verhaak, R. G. W., Hoadley, K. A., Purdom, E., Wang, V., Qi, Y., Wilkerson, M. D., ..., Cancer Genome Atlas Research Network. Integrated genomic analysis identifies clinically relevant subtypes of glioblastoma characterized by abnormalities in PDGFRA, IDH1, EGFR, and NF1. \emph{Cancer Cell}, 2010, 17(1), 98-110. 
}
\examples{
data("TCGA")
}
\keyword{datasets}

\name{MultiMeasure}
\alias{MultiMeasure}

\title{
MultiMeasure Constructor
}

\description{
Creates a \code{MultiMeasure} object from a set of 3 or more numeric matrices, in preparation to pass to \code{fitConsensus}.
}

\usage{
MultiMeasure(names=NA_character_, data=list())
}

\arguments{
  \item{names}{character vector contains the names of each data type (e.g. RNA-Seq, Agilent etc.). Must be the same \code{length} as \code{data}.}
  \item{data}{list of numeric matrices of identical \code{dim}, \code{rownames} and \code{colnames} where each matrix contains the measurements from the platform/condition described in \code{names}. Rows of each matrix correspond to genomic features and columns to samples. Must be the same length as, and have order correspond to, \code{names}.}
  
}

\details{
A MultiMeasure contains a list of numeric matrices with identical dimensions and matching row names and column names, to which multiple row-linear models can be fit using \code{fitConsensus}. Users should pass a vector of \code{names} describing the platform/conditions the genomic measurements are made under, and a corresponding list of matrices to the \code{data} argument. A series of validity checks will be made on data correctness and a helpful error message will be returned if the structure does not conform to the above description.
}

\value{a \code{\link{MultiMeasure}} object}

\author{Tim Peters <t.peters@garvan.org.au>}

\seealso{\code{MultiMeasure-class}}

\examples{
data(TCGA)
tcga_mm <- MultiMeasure(names=c("U133A", "Huex", "Agilent", "RNA-Seq"), 
			data=list(U133A, Huex, Agilent, RNASeq))
}

\name{consensus-internal}
\title{
Internal consensus objects and functions
}
\alias{checkMM}
\alias{fitMandel}
\alias{getBlock}
\description{
Internal consensus objects and functions
}
\keyword{internal}

\name{plotMarginals}
\alias{plotMarginals}
\title{
Density plots of per-platform marginal distributions
}
\description{
Plots a series of marginal densities for each platform for either (a) average, (b) sensitivity or (c) precision. 
}
\usage{
plotMarginals(consfit, 
	      param=c("average", "sensitivity", "precision"), 
	      pal=palette(), xlim=NULL, ...)
}

\arguments{
  \item{consfit}{An object of class \code{ConsensusFit}.}
  \item{param}{Whether average (\eqn{a_i}), sensitivity (\eqn{b_i}) or precision (\eqn{d_i}) is plotted.}
  \item{pal}{Colour palette. Length must be at least the number of platforms/conditions.}
  \item{xlim}{Range of values to be plotted. If \code{NULL} then the entire density is plotted.}
  \item{\dots}{Extra arguments passed to \code{legend()}.}
}

\details{
Precision is plotted on the log scale.
}
\value{
A plot to the current device.
}

\author{
Tim Peters  <t.peters@garvan.org.au>
}
\examples{
data("TCGA")
tcga_mm <- MultiMeasure(names=c("U133A", "Huex", "Agilent", "RNASeq"), 
			data=list(U133A, Huex, Agilent, RNASeq))
fit <- fitConsensus(tcga_mm)
plotMarginals(fit, "sensitivity", brewer.pal(n = 4, name = "Dark2"))
}

\name{fitConsensus}
\alias{fitConsensus}
\title{
  Fit row-linear models to all loci
}
\description{
  The main function of this package. Fits a number of row-linear models from a \code{\link{MultiMeasure}} object, one for each matching row of the data matrices contained within it. Outputs a \code{ConsensusFit} object containing per-platform, per locus consensus values for average, sensitivity and precision. 
}
\usage{
  fitConsensus(multimeas)
}
\arguments{
  \item{multimeas}{
    An object of class \code{\link{MultiMeasure}}. 
  }
}

\details{
  For each locus, a row-linear model (Mandel 1994) is fit of the form \deqn{Z_{ij} = a_{i} + b_{i}(x_{j} - \bar{x}) + d_{ij}} where \eqn{Z_{ij}} is a matrix of measurements at the same genomic locus \eqn{k}, the row index \eqn{i=1,\ldots,p} labels the platform or condition (microarray, library prep method for sequencing assay etc.) used and the column index \eqn{j=1,\ldots,n} labels the biological samples that are interrogated at that locus on each of the \eqn{p} platforms. Hence \eqn{a_{i}} is the intercept (row averages of \eqn{Z_{ij}}), \eqn{b_{i}} the slope of the regression line (sensitivity) and \eqn{d_i = (n-2)^{-1}\Sigma_{j}d_{ij}^{2}} the residual mean square (precision) about the \emph{i}th fitted line, noting that higher \eqn{d_i} corresponds to lower precision. Values of \eqn{a_i}, \eqn{b_i} and \eqn{d_i} can be found in the slots of the \code{ConsensusFit} object.

For \code{\link{MultiMeasure}} objects with 10,000 loci or more, a progress message is printed for every 10,000 loci fitted.

}

\value{
  A \code{ConsensusFit} object with slots containing various parameter values from the row-linear fits. More information can be found in the linked class description. Output from this function can then be passed to various plotting functions for data exploration.
}

\references{

Mandel, J. (1994). Analyzing Interlaboratory Data According to ASTM Standard E691. In \emph{Quality and Statistics: Total Quality Management} (pp. 59-59-12). 100 Barr Harbor Drive, PO Box C700, West Conshohocken, PA 19428-2959: ASTM International.
  
Mandel, J. (2012). The statistical analysis of experimental data. Courier Corporation. Chapter 13: ``The Systematic Evaluation of Measuring Processes''.

Ku, H.H. (1969). Precision Measurement and Calibration. Volume 1. Statistical Concepts and Procedures (No. NBS-SP-300-VOL-1). Issued February 1969. US Department of Commerce. Chapter 3.7: ``The Interlaboratory Evaluation of Testing Methods''. Mandel, J. and Lashof, T.W. p. 170.
  
}
\author{
  Tim Peters <t.peters@garvan.org.au>
}
\examples{
data("TCGA")
tcga_mm <- MultiMeasure(names=c("U133A", "Huex", "Agilent", "RNA-Seq"),
			data=list(U133A, Huex, Agilent, RNASeq))
fit <- fitConsensus(tcga_mm)
}

\name{plotOneFit}
\alias{plotOneFit}
\title{
Plot a single row-linear fit from a genomic locus
}
\description{
Plots a series of regressions of platform measurements against their consensus mean.
}
\usage{
plotOneFit(multimeas, idx, pal=palette(), ...)
}

\arguments{
  \item{multimeas}{An object of class \code{MultiMeasure.}}
  \item{idx}{Row index of the set of matrices in \code{multimeas}.}
  \item{pal}{Color palette. Length must be at least the length of multimeas@data.}
  \item{\dots}{Extra arguments passed to \code{legend()}.}
}

\details{
Visualises a row-linear fit explicitly in the measurement space. Steeper (positive) slopes mean greater sensitivity, and greater scatter around the regression line indicates lower precision.
}
\value{
A plot to the current device.
}

\author{
Tim Peters <t.peters@garvan.org.au>
}
\examples{
data("TCGA")
tcga_mm <- MultiMeasure(names=c("U133A", "Huex", "Agilent", "RNASeq"), 
			data=list(U133A, Huex, Agilent, RNASeq))
plotOneFit(tcga_mm, "TP53", brewer.pal(n = 4, name = "Dark2"))
}

\name{MultiMeasure-class}
\alias{MultiMeasure-class}
\docType{class}
\title{Multi-platform genomic measurements across the same samples - class}

\description{
An S4 class that stores normalised matched genomic data from multiple platforms and/or laboratory conditions (e.g. from microarrays, RNA-Seq and other sequencing assays).
}

\section{List Components}{
This class has two slots, \code{names} and \code{data}.
\describe{
  \item{\code{names}:}{ character vector contains the names of each data type (e.g. RNA-Seq, Agilent etc.). Must be the same \code{length} as \code{data}.}
  \item{\code{data}:}{ list of numeric matrices of identical \code{dim}, \code{rownames} and \code{colnames} where each matrix contains the measurements from the platform/condition described in \code{names}. Rows of each matrix correspond to genomic features and columns to samples. Must be the same length as \code{names}.}
}
}

\seealso{
\code{\link{MultiMeasure}} constructs MultiMeasure objects.
}

\section{Methods}{

\code{MultiMeasure} objects have a \code{show} method that describes the dimensions of the data, in the form: \code{MultiMeasure object with i platforms/conditions, j samples and k measured loci}.
}

\author{Tim Peters <t.peters@garvan.org.au>}

\keyword{classes}

\name{ConsensusFit-class}
\alias{ConsensusFit-class}
\docType{class}
\title{Row-linear fit from multiple platforms/conditions - class}

\description{
  An S4 class that stores parameter value output from \code{\link{fitConsensus}}.
}

\section{Slots}{
  This class has eight slots, each containing parameters from the row-linear fit:
  \describe{
    \item{\code{a_i}:}{ Platform-wise average (intercepts).}
    \item{\code{b_i}:}{ Platform-wise sensitivity (slopes).}
    \item{\code{d_i}:}{ Platform-wise precision (residual mean squares). Note that higher values correspond to lower precision.}
    \item{\code{V_a}:}{ Variance of \code{a_i}. High values indicate high discordance in dynamic range.}
    \item{\code{V_b}:}{ Variance of \code{b_i}. High values indicate high discordance in sensitivity.}
    \item{\code{V_d}:}{ Averaged precision across platforms.}
    \item{\code{z0}:}{ Point of approximate concurrence for all regression lines. Only applicable when \code{a_i} and \code{b_i} are highly correlated. See Equations 13.16 and 13.39 of Mandel (2012).}
    \item{\code{Vdelta}:}{ Residual variance about the line when \code{b_i} is regressed against \code{a_i}. Lower values indicate a higher degree of concurrence, assuming that \code{a_i} and \code{b_i} are highly correlated. See Equation 13.36 of Mandel (2012).}
  }
}

\seealso{
  \code{\link{fitConsensus}}: outputs \code{ConsensusFit} objects.
}

\section{Methods}{
  
  \code{ConsensusFit} objects have a \code{show} method that describes the dimensions of the data, in the form: \code{"ConsensusFit object with i platforms/conditions and k measured loci"}.
}

\references{

Mandel, J. (2012). The statistical analysis of experimental data. Courier Corporation. Chapter 13: \emph{The Systematic Evaluation of Measuring Processes}.

}

\author{ 
Tim Peters <t.peters@garvan.org.au>
}

\keyword{classes}

\name{consensus-package}
\alias{consensus-package}
\alias{consensus}
\docType{package}
\title{
Cross-platform consensus analysis of genomic measurements via interlaboratory testing method
}
\description{
An implementation of the American Society for Testing and
Materials (ASTM) Standard E691 for interlaboratory testing 
procedures, designed for cross-platform genomic measurements. 
Given three (3) or more genomic platforms or laboratory 
protocols, this package provides interlaboratory testing 
procedures giving per-locus comparisons for sensitivity 
and precision between platforms.
}
\author{
Tim J. Peters <t.peters@garvan.org.au>
}

\examples{
data("TCGA")
tcga_mm <- MultiMeasure(names=c("U133A", "Huex", "Agilent", "RNA-Seq"), 
			data=list(U133A, Huex, Agilent, RNASeq))
fit <- fitConsensus(tcga_mm)
}
